varying vec3 normal, vVertex;
varying vec2 texCoord;

uniform sampler2D osgShadow_baseTexture;
uniform sampler2DShadow osgShadow_shadowTexture;

uniform int maximum;
uniform bool shadowsEnabled;
uniform bool colorMaterial;

uniform vec4 special;

void main()
{	
	vec4 final_color = vec4(0.0);
	
	vec4 ambient	= vec4(0.0);
	vec4 diffuse	= vec4(0.0);
	
	ambient = gl_FrontMaterial.emission + gl_FrontMaterial.ambient * gl_LightModel.ambient;
	diffuse = gl_FrontMaterial.diffuse;
	
	vec4 texColor	= texture2D(osgShadow_baseTexture, texCoord);
	
	for(int i=0; i<maximum; i++)
	{

		vec3 lightDir = vec3(gl_LightSource[i].position.xyz - vVertex);
		
		float att = length(lightDir);
		
		att = 1.0 / 0.6;

		final_color += ambient + (gl_LightSource[i].ambient * gl_FrontMaterial.ambient)*att;
								
		vec3 N = normalize(normal);
		vec3 L = normalize(lightDir);
		
		float lambertTerm = dot(N,L);
		
		vec3 R = reflect(-L, N);
		vec3 E = normalize(-vVertex);
		
		if(lambertTerm > 0.0)
		{
				final_color +=  special * diffuse * lambertTerm * att ;
		}
	}

	if(texColor != vec4(0.0))
		final_color *= texColor;		

	gl_FragColor = final_color ;			
		
	gl_FragColor.a = gl_Color.a;
}