uniform mat4 viewMatrixInverse;

varying vec3 normal, wNormal;
varying vec3 vertex;
varying vec4 wVertex;
varying vec2 texCoord;

void main( void )
{
	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
	texCoord = gl_MultiTexCoord0.xy;
	gl_TexCoord[0] = gl_MultiTexCoord0;
	
	//lighting
	normal = gl_NormalMatrix * gl_Normal;
	vertex = vec3(gl_ModelViewMatrix * gl_Vertex);
	
	//world coordinates
	mat4 modelMatrix = viewMatrixInverse*gl_ModelViewMatrix;
	wNormal = vec4(modelMatrix*vec4(gl_Normal,0.0)).xyz;
	wVertex = modelMatrix * gl_Vertex;
}